You can customize the properties of connectorShapes using the ConnectorShape API:
style: Gets or sets the style of the connector shape.
import * as React from 'react';
import { createRoot } from 'react-dom/client';
import './styles.css';
import { AppFunc } from './app-func';
// import { App } from './app-class';
// 1. Functional Component sample
createRoot(document.getElementById('app')).render(<AppFunc />);
// 2. Class Component sample
// createRoot(document.getElementById('app')).render(<App />);
import * as React from 'react';
import GC from '@mescius/spread-sheets';
import "@mescius/spread-sheets-shapes"
import { SpreadSheets } from '@mescius/spread-sheets-react';
import { Panel } from "./panel";
let spread = null;
export function AppFunc() {
const [showConnectorPropPanel, setShowConnectorPropPanel] = React.useState(false);
const updateConnectorShapeStyle = (action, value) => {
let sheet = spread.getActiveSheet();
let activeShape = sheet.shapes.all().filter(function (sp) {
return sp.isSelected() && sp instanceof GC.Spread.Sheets.Shapes.ConnectorShape;
});
if (activeShape.length > 0) {
activeShape.forEach((shape) => {
_setConnectorShapeStyle(shape, action, value);
});
sheet.repaint();
}
}
const _setConnectorShapeStyle = (shape, action, value) => {
let shapeStyle = shape.style();
let shapeStyleLine = shapeStyle.line;
switch (action) {
case "beginStyle": {
shapeStyleLine.beginArrowheadStyle = value;
break;
}
case "beginWidth": {
shapeStyleLine.beginArrowheadWidth = value;
break;
}
case "beginLength": {
shapeStyleLine.beginArrowheadLength = value;
break;
}
case "endStyle": {
shapeStyleLine.endArrowheadStyle = value;
break;
}
case "endWidth": {
shapeStyleLine.endArrowheadWidth = value;
break;
}
case "endLength": {
shapeStyleLine.endArrowheadLength = value;
break;
}
}
shape.style(shapeStyle);
}
const setConnectorPropVisibility = (isShow) => {
setShowConnectorPropPanel(isShow);
}
const initSpread = (currSpread) => {
spread = currSpread;
var line1 = spread.getActiveSheet().shapes.addConnector("line", GC.Spread.Sheets.Shapes.ConnectorType.straight, 20, 40, 200, 110);
var line2 = spread.getActiveSheet().shapes.addConnector("line", GC.Spread.Sheets.Shapes.ConnectorType.straight, 20, 110, 200, 190);
var line3 = spread.getActiveSheet().shapes.addConnector("line", GC.Spread.Sheets.Shapes.ConnectorType.elbow, 300, 40, 500, 90);
var line4 = spread.getActiveSheet().shapes.addConnector("line", GC.Spread.Sheets.Shapes.ConnectorType.elbow, 300, 130, 500, 190);
var lineShapeStyle = line1.style();
lineShapeStyle.line.width = 3;
lineShapeStyle.line.color = "#82BC00";
line1.style(lineShapeStyle);
line2.style(lineShapeStyle);
line3.style(lineShapeStyle);
line4.style(lineShapeStyle);
bindSpreadEvent();
}
const bindSpreadEvent = () => {
spread.bind(GC.Spread.Sheets.Events.ShapeSelectionChanged, function () {
let sheet = spread.getActiveSheet();
var selectedShape = sheet.shapes.all().filter(function (sp) {
return sp.isSelected();
});
var isShapeSelected = false,
isConnectorSelected = false;
if (selectedShape.length > 0) {
selectedShape.forEach((shape) => {
if (!isShapeSelected && shape instanceof GC.Spread.Sheets.Shapes.Shape) {
isShapeSelected = true;
} else if (!isConnectorSelected && shape instanceof GC.Spread.Sheets.Shapes.ConnectorShape) {
isConnectorSelected = true;
}
});
setConnectorPropVisibility(isConnectorSelected);
} else {
setConnectorPropVisibility(false);
}
})
}
return (<div class="sample-tutorial">
<div class="sample-spreadsheets">
<SpreadSheets workbookInitialized={spread => initSpread(spread)}>
</SpreadSheets>
</div>
<Panel
showConnectorPropPanel={showConnectorPropPanel}
updateConnectorShapeStyle={(action, value) => { updateConnectorShapeStyle(action, value) }}>
</Panel>
</div>);
}
import * as React from 'react';
import GC from '@mescius/spread-sheets';
import "@mescius/spread-sheets-shapes"
import { SpreadSheets } from '@mescius/spread-sheets-react';
import { Panel } from "./panel";
const Component = React.Component;
export class App extends Component {
constructor(props) {
super(props);
this.spread = null;
this.autoGenerateColumns = false;
this.state = {
showBorderPanel: false,
showConnectorPropPanel: false,
showShapeTxtPanel: false,
showShapeFillPropPanel: false
}
}
render() {
const {
showBorderPanel,
showConnectorPropPanel,
showShapeTxtPanel,
showShapeFillPropPanel
} = this.state;
return (<div class="sample-tutorial">
<div class="sample-spreadsheets">
<SpreadSheets workbookInitialized={spread => this.initSpread(spread)}>
</SpreadSheets>
</div>
<Panel
showBorderPanel={showBorderPanel}
showConnectorPropPanel={showConnectorPropPanel}
showShapeTxtPanel={showShapeTxtPanel}
showShapeFillPropPanel={showShapeFillPropPanel}
insertShape={(addShapeType) => { this.insertShape(addShapeType) }}
insertConnectShape={(addConnectorShapeType) => { this.insertConnectShape(addConnectorShapeType) }}
updateShapeStyle={(action, value) => { this.updateShapeStyle(action, value) }}
updateShapeBorderStyle={(action, value) => { this.updateShapeBorderStyle(action, value) }}
updateConnectorShapeStyle={(action, value) => { this.updateConnectorShapeStyle(action, value) }}>
</Panel>
</div>);
}
updateShapeStyle(action, value) {
let sheet = this.spread.getActiveSheet();
let activeShape = sheet.shapes.all().filter(function (sp) {
return sp.isSelected();
});
if (activeShape.length > 0) {
activeShape.forEach((shape) => {
if (shape instanceof GC.Spread.Sheets.Shapes.Shape) {
this._setShapeStyle(shape, action, value);
}
});
sheet.repaint();
}
}
updateShapeBorderStyle(action, value) {
let sheet = this.spread.getActiveSheet();
let activeShape = sheet.shapes.all().filter(function (sp) {
return sp.isSelected();
});
if (activeShape.length > 0) {
activeShape.forEach(function (shape) {
let shapeStyle = shape.style();
shapeStyle.line[action] = value;
shape.style(shapeStyle);
});
sheet.repaint();
}
}
updateConnectorShapeStyle(action, value) {
let sheet = this.spread.getActiveSheet();
let activeShape = sheet.shapes.all().filter(function (sp) {
return sp.isSelected() && sp instanceof GC.Spread.Sheets.Shapes.ConnectorShape;
});
if (activeShape.length > 0) {
activeShape.forEach((shape) => {
this._setConnectorShapeStyle(shape, action, value);
});
sheet.repaint();
}
}
_setConnectorShapeStyle(shape, action, value) {
let shapeStyle = shape.style();
let shapeStyleLine = shapeStyle.line;
switch (action) {
case "beginStyle": {
shapeStyleLine.beginArrowheadStyle = value;
break;
}
case "beginWidth": {
shapeStyleLine.beginArrowheadWidth = value;
break;
}
case "beginLength": {
shapeStyleLine.beginArrowheadLength = value;
break;
}
case "endStyle": {
shapeStyleLine.endArrowheadStyle = value;
break;
}
case "endWidth": {
shapeStyleLine.endArrowheadWidth = value;
break;
}
case "endLength": {
shapeStyleLine.endArrowheadLength = value;
break;
}
}
shape.style(shapeStyle);
}
_setShapeStyle(shape, action, value) {
if (action === 'rotate') {
shape.rotate(value);
} else if (action === 'text') {
shape.text(value);
} else {
var shapeStyle = shape.style();
if (action === 'background') {
shapeStyle.fill.color = value;
} else if (action === 'transparency') {
shapeStyle.fill.transparency = value;
} else if (action === 'color') {
shapeStyle.textEffect.color = value;
} else if (action === 'transparencyTxt') {
shapeStyle.textEffect.transparency = value;
} else if (action === 'font') {
shapeStyle.textEffect.font = value;
} else if (action === 'hAlign') {
shapeStyle.textFrame.hAlign = parseInt(value);
} else if (action === 'vAlign') {
shapeStyle.textFrame.vAlign = parseInt(value);
}
shape.style(shapeStyle);
}
}
insertShape(addShapeType) {
let sheet = this.spread.getActiveSheet(),
shapes = sheet.shapes,
total = shapes.all().length;
let x = 40 + (total % 2) * 250,
y = parseInt(total / 2) * 200 + 20;
let shape = shapes.add('', addShapeType, x, y);
this._setShapeStyle(shape, 'hAlign', 1);
}
insertConnectShape(addConnectorShapeType) {
let sheet = this.spread.getActiveSheet(), shapes = sheet.shapes, total = shapes.all().length;
let x = 40 + (total % 2) * 250, y = parseInt(total / 2) * 200 + 20;
shapes.addConnector('', parseInt(addConnectorShapeType), x, y, x + 200, y + 200);
}
setBorderPropVisibility(isShow) {
this.setState({ showBorderPanel: isShow });
}
setConnectorPropVisibility(isShow) {
this.setState({ showConnectorPropPanel: isShow });
}
setShapePropVisibility(isShow) {
this.setState({ showShapeTxtPanel: isShow, showShapeFillPropPanel: isShow })
}
initSpread(spread) {
this.spread = spread;
var line1 = spread.getActiveSheet().shapes.addConnector("line", GC.Spread.Sheets.Shapes.ConnectorType.straight, 20, 40, 200, 110);
var line2 = spread.getActiveSheet().shapes.addConnector("line", GC.Spread.Sheets.Shapes.ConnectorType.straight, 20, 110, 200, 190);
var line3 = spread.getActiveSheet().shapes.addConnector("line", GC.Spread.Sheets.Shapes.ConnectorType.elbow, 300, 40, 500, 90);
var line4 = spread.getActiveSheet().shapes.addConnector("line", GC.Spread.Sheets.Shapes.ConnectorType.elbow, 300, 130, 500, 190);
var lineShapeStyle = line1.style();
lineShapeStyle.line.width = 3;
lineShapeStyle.line.color = "#82BC00";
line1.style(lineShapeStyle);
line2.style(lineShapeStyle);
line3.style(lineShapeStyle);
line4.style(lineShapeStyle);
this.bindSpreadEvent();
}
bindSpreadEvent() {
let spread = this.spread,
self = this;
spread.bind(GC.Spread.Sheets.Events.ShapeSelectionChanged, function () {
let sheet = spread.getActiveSheet();
var selectedShape = sheet.shapes.all().filter(function (sp) {
return sp.isSelected();
});
var isShapeSelected = false,
isConnectorSelected = false;
if (selectedShape.length > 0) {
selectedShape.forEach((shape) => {
if (!isShapeSelected && shape instanceof GC.Spread.Sheets.Shapes.Shape) {
isShapeSelected = true;
} else if (!isConnectorSelected && shape instanceof GC.Spread.Sheets.Shapes.ConnectorShape) {
isConnectorSelected = true;
}
});
self.setShapePropVisibility(isShapeSelected);
self.setConnectorPropVisibility(isConnectorSelected);
self.setBorderPropVisibility(true);
} else {
self.setShapePropVisibility(false);
self.setConnectorPropVisibility(false);
self.setBorderPropVisibility(false);
}
})
}
}
import * as React from 'react';
import GC from '@mescius/spread-sheets';
export function Panel(props) {
const arrowheadLength = {
"short": 0,
"medium": 1,
"long": 2
};
const arrowheadWidth = {
"narrow": 0,
"medium": 1,
"wide": 2
};
const [panelInfo, setPanelInfo] = React.useState({
beginStyle: 3,
beginWidth: 1,
beginLength: 2,
endStyle: 3,
endWidth: 1,
endLength: 2,
arrowHeadLengthList: getEnumList(arrowheadLength),
arrowHeadWidthList: getEnumList(arrowheadWidth),
arrowHeadStyle: getEnumList(GC.Spread.Sheets.Shapes.ArrowheadStyle)
});
React.useEffect(() => {
setPanelInfo({
beginStyle: 3,
beginWidth: 1,
beginLength: 2,
endStyle: 3,
endWidth: 1,
endLength: 2,
arrowHeadLengthList: getEnumList(arrowheadLength),
arrowHeadWidthList: getEnumList(arrowheadWidth),
arrowHeadStyle: getEnumList(GC.Spread.Sheets.Shapes.ArrowheadStyle)
});
}, [props.showConnectorPropPanel]);
return (<div class="options-container">
<div class="option-row">
Select a shape and change the arrow-head properties to see the effect.
</div>
<div id="divideLine" class="divide-line"></div>
{
props.showConnectorPropPanel &&
<div v-show="showConnectorPropPanel" class="option-row">
<label for="beginArrowheadStyle">Begin Arrowhead Style:</label>
<select value={panelInfo.beginStyle} class="shapeSelect" onChange={(event) => { setPanelInfo({ ...panelInfo, beginStyle: parseInt(event.target.value, 10) }); }}>
{panelInfo.arrowHeadStyle.map(({ name, value }) => {
return <option value={value} key={name}>{name}</option>
})}
</select>
<input onClick={() => { props.updateConnectorShapeStyle('beginStyle', panelInfo.beginStyle) }} type="button" class='arrow-action-button' value="Set" />
<label>Begin Arrowhead Width:</label>
<select value={panelInfo.beginWidth} class="shapeSelect" onChange={(event) => { setPanelInfo({ ...panelInfo, beginWidth: parseInt(event.target.value, 10) }); }}>
{panelInfo.arrowHeadWidthList.map(({ name, value }) => {
return <option value={value} key={name}>{name}</option>
})}
</select >
<input type="button" onClick={() => { props.updateConnectorShapeStyle('beginWidth', panelInfo.beginWidth) }} class='arrow-action-button' value="Set" />
<label>Begin Arrowhead Length:</label>
<select value={panelInfo.beginLength} class="shapeSelect" onChange={(event) => { setPanelInfo({ ...panelInfo, beginLength: parseInt(event.target.value, 10) }); }}>
{panelInfo.arrowHeadLengthList.map(({ name, value }) => {
return <option value={value} key={name}>{name}</option>
})}
</select >
<input type="button" onClick={() => { props.updateConnectorShapeStyle('beginLength', panelInfo.beginLength) }} class='arrow-action-button' value="Set" />
<label for="endArrowheadStyle">End Arrowhead Style:</label>
<select value={panelInfo.endStyle} class="shapeSelect" onChange={(event) => { setPanelInfo({ ...panelInfo, endStyle: parseInt(event.target.value, 10) }); }}>
{panelInfo.arrowHeadStyle.map(({ name, value }) => {
return <option value={value} key={name}>{name}</option>
})}
</select >
<input type="button" onClick={() => { props.updateConnectorShapeStyle('endStyle', panelInfo.endStyle) }} class='arrow-action-button' value="Set" />
<label>End Arrowhead Width:</label>
<select value={panelInfo.endWidth} class="shapeSelect" onChange={(event) => { setPanelInfo({ ...panelInfo, endWidth: parseInt(event.target.value, 10) }); }}>
{panelInfo.arrowHeadWidthList.map(({ name, value }) => {
return <option value={value} key={name}>{name}</option>
})}
</select >
<input type="button" onClick={() => { props.updateConnectorShapeStyle('endWidth', panelInfo.endWidth) }} class='arrow-action-button' value="Set" />
<label>End Arrowhead Length:</label>
<select value={panelInfo.endLength} class="shapeSelect" onChange={(event) => { setPanelInfo({ ...panelInfo, endLength: parseInt(event.target.value, 10) }); }}>
{panelInfo.arrowHeadLengthList.map(({ name, value }) => {
return <option value={value} key={name}>{name}</option>
})}
</select >
<input type="button" onClick={() => { props.updateConnectorShapeStyle('endLength', panelInfo.endLength) }} class='arrow-action-button' value="Set" />
</div >
}
</div >);
}
function getEnumList(enumObject) {
let names = [];
for (var name in enumObject) {
if (name === "none" || (parseInt(name, 10)) == name) {
continue;
}
names.push({
name: name,
value: enumObject[name]
});
}
names.sort(function (a, b) {
return a.name > b.name ? 1 : -1
});
return names;
}
<!doctype html>
<html style="height:100%;font-size:14px;">
<head>
<meta charset="utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0" />
<link rel="stylesheet" type="text/css" href="$DEMOROOT$/en/react/node_modules/@mescius/spread-sheets/styles/gc.spread.sheets.excel2013white.css">
<!-- SystemJS -->
<script src="$DEMOROOT$/en/react/node_modules/systemjs/dist/system.src.js"></script>
<script src="systemjs.config.js"></script>
<script>
System.import('$DEMOROOT$/en/lib/react/license.js').then(function () {
System.import('./src/app');
});
</script>
</head>
<body>
<div id="app"></div>
</body>
</html>
.sample-tutorial {
position: relative;
height: 100%;
overflow: hidden;
}
.sample-spreadsheets {
width: calc(100% - 280px);
height: 100%;
overflow: hidden;
float: left;
}
.options-container {
float: right;
width: 280px;
padding: 12px;
height: 100%;
box-sizing: border-box;
background: #fbfbfb;
overflow: auto;
}
.option-row {
font-size: 14px;
padding-left: 5px;
}
.divide-line {
width: 100%;
height: 1px;
background: #cbcbcb;
margin-top: 10px;
margin-bottom: 3px;
}
.title {
text-align: center;
font-weight: bold;
}
label {
display: block;
margin-top: 15px;
margin-bottom: 5px;
}
p {
padding: 2px 10px;
background-color: #F4F8EB;
}
input {
width: 160px;
margin-left: 10px;
display: inline;
}
input[type=button] {
width: 50px;
margin-left: 1px;
}
select {
width: 160px;
margin-left: 10px;
display: inline;
}
textarea {
width: 160px;
margin-left: 10px;
}
body {
position: absolute;
top: 0;
bottom: 0;
left: 0;
right: 0;
}
#app{
width: 100%;
height: 100%;
}
(function (global) {
System.config({
transpiler: 'plugin-babel',
babelOptions: {
es2015: true,
react: true
},
meta: {
'*.css': { loader: 'css' }
},
paths: {
// paths serve as alias
'npm:': 'node_modules/'
},
// map tells the System loader where to look for things
map: {
'@mescius/spread-sheets': 'npm:@mescius/spread-sheets/index.js',
'@mescius/spread-sheets-react': 'npm:@mescius/spread-sheets-react/index.js',
'@mescius/spread-sheets-shapes': 'npm:@mescius/spread-sheets-shapes/index.js',
'@grapecity/jsob-test-dependency-package/react-components': 'npm:@grapecity/jsob-test-dependency-package/react-components/index.js',
'react': 'npm:react/cjs/react.production.js',
'react-dom': 'npm:react-dom/cjs/react-dom.production.js',
'react-dom/client': 'npm:react-dom/cjs/react-dom-client.production.js',
'scheduler': 'npm:scheduler/cjs/scheduler.production.js',
'css': 'npm:systemjs-plugin-css/css.js',
'plugin-babel': 'npm:systemjs-plugin-babel/plugin-babel.js',
'systemjs-babel-build':'npm:systemjs-plugin-babel/systemjs-babel-browser.js'
},
// packages tells the System loader how to load when no filename and/or no extension
packages: {
src: {
defaultExtension: 'jsx'
},
"node_modules": {
defaultExtension: 'js'
},
}
});
})(this);

You can customize the properties of connectorShapes using the ConnectorShape API:
style: Gets or sets the style of the connector shape.
import { Component, NgModule, enableProdMode } from '@angular/core';
import { FormsModule } from '@angular/forms';
import { BrowserModule } from '@angular/platform-browser';
import { platformBrowserDynamic } from '@angular/platform-browser-dynamic';
import { SpreadSheetsModule } from '@mescius/spread-sheets-angular';
import GC from '@mescius/spread-sheets';
import "@mescius/spread-sheets-shapes"
import './styles.css';
function getEnumList(enumObject: object) {
let names = [];
for (var name in enumObject) {
if (name === "none" || (parseInt(<any>name, 10)) == <any>name) {
continue;
}
names.push({
name: name,
value: enumObject[name]
});
}
names.sort(function(a, b) {
return a.name > b.name ? 1 : -1
});
return names;
}
const arrowheadLength = {
"short": 0,
"medium": 1,
"long": 2
};
const arrowheadWidth = {
"narrow": 0,
"medium": 1,
"wide": 2
};
@Component({
selector: 'app-component',
templateUrl: 'src/app.component.html'
})
export class AppComponent {
spread: GC.Spread.Sheets.Workbook;
hostStyle = {
width: 'calc(100% - 280px)',
height: '100%',
overflow: 'hidden',
float: 'left'
};
showConnectorPropPanel = false;
beginStyle = 3;
beginWidth = 1;
beginLength = 2;
endStyle = 3;
endWidth = 1;
endLength = 2;
arrowHeadLengthList = getEnumList(arrowheadLength);
arrowHeadWidthList = getEnumList(arrowheadWidth);
arrowHeadStyle = getEnumList(GC.Spread.Sheets.Shapes.ArrowheadStyle);
initSpread($event: any) {
let spread = this.spread = $event.spread;
var line1 = spread.getActiveSheet().shapes.addConnector("line", GC.Spread.Sheets.Shapes.ConnectorType.straight, 20, 40, 200, 110);
var line2 = spread.getActiveSheet().shapes.addConnector("line", GC.Spread.Sheets.Shapes.ConnectorType.straight, 20, 110, 200, 190);
var line3 = spread.getActiveSheet().shapes.addConnector("line", GC.Spread.Sheets.Shapes.ConnectorType.elbow, 300, 40, 500, 90);
var line4 = spread.getActiveSheet().shapes.addConnector("line", GC.Spread.Sheets.Shapes.ConnectorType.elbow, 300, 130, 500, 190);
var lineShapeStyle = line1.style();
lineShapeStyle.line.width = 3;
lineShapeStyle.line.color = "#82BC00";
line1.style(lineShapeStyle);
line2.style(lineShapeStyle);
line3.style(lineShapeStyle);
line4.style(lineShapeStyle);
this.bindSpreadEvent();
}
bindSpreadEvent() {
let spread = this.spread,
self = this;
spread.bind(GC.Spread.Sheets.Events.ShapeSelectionChanged, function() {
let sheet = spread.getActiveSheet();
var selectedShape = sheet.shapes.all().filter(function(sp: GC.Spread.Sheets.Shapes.ShapeBase) {
return sp.isSelected();
});
var isShapeSelected = false,
isConnectorSelected = false;
if (selectedShape.length > 0) {
selectedShape.forEach((shape: GC.Spread.Sheets.Shapes.ShapeBase) => {
if (!isShapeSelected && shape instanceof GC.Spread.Sheets.Shapes.Shape) {
isShapeSelected = true;
} else if (!isConnectorSelected && shape instanceof GC.Spread.Sheets.Shapes.ConnectorShape) {
isConnectorSelected = true;
}
});
self.setConnectorPropVisibility(isConnectorSelected);
} else {
self.setConnectorPropVisibility(false);
}
})
}
setConnectorPropVisibility(isShow: boolean) {
this.showConnectorPropPanel = isShow;
}
updateConnectorShapeStyle(action: string, value: any) {
let sheet = this.spread.getActiveSheet();
let activeShape = sheet.shapes.all().filter(function(sp: GC.Spread.Sheets.Shapes.ShapeBase) {
return sp.isSelected() && sp instanceof GC.Spread.Sheets.Shapes.ConnectorShape;
});
if (activeShape.length > 0) {
activeShape.forEach((shape: GC.Spread.Sheets.Shapes.ShapeBase) => {
this._setConnectorShapeStyle(shape, action, value);
});
sheet.repaint();
}
}
_setConnectorShapeStyle(shape: GC.Spread.Sheets.Shapes.ShapeBase, action: string, value: any) {
let shapeStyle = shape.style();
let shapeStyleLine = shapeStyle.line;
switch (action) {
case "beginStyle": {
shapeStyleLine.beginArrowheadStyle = value;
break;
}
case "beginWidth": {
shapeStyleLine.beginArrowheadWidth = value;
break;
}
case "beginLength": {
shapeStyleLine.beginArrowheadLength = value;
break;
}
case "endStyle": {
shapeStyleLine.endArrowheadStyle = value;
break;
}
case "endWidth": {
shapeStyleLine.endArrowheadWidth = value;
break;
}
case "endLength": {
shapeStyleLine.endArrowheadLength = value;
break;
}
}
shape.style(shapeStyle);
}
}
@NgModule({
imports: [BrowserModule, SpreadSheetsModule, FormsModule],
declarations: [AppComponent],
exports: [AppComponent],
bootstrap: [AppComponent]
})
export class AppModule { }
enableProdMode();
platformBrowserDynamic().bootstrapModule(AppModule);
<!doctype html>
<html style="height:100%;font-size:14px;">
<head>
<meta charset="utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0" />
<link rel="stylesheet" type="text/css" href="$DEMOROOT$/en/angular/node_modules/@mescius/spread-sheets/styles/gc.spread.sheets.excel2013white.css">
<!-- Polyfills -->
<script src="$DEMOROOT$/en/angular/node_modules/core-js/client/shim.min.js"></script>
<script src="$DEMOROOT$/en/angular/node_modules/zone.js/fesm2015/zone.min.js"></script>
<!-- SystemJS -->
<script src="$DEMOROOT$/en/angular/node_modules/systemjs/dist/system.js"></script>
<script src="systemjs.config.js"></script>
<script>
// workaround to load 'rxjs/operators' from the rxjs bundle
System.import('rxjs').then(function (m) {
System.import('@angular/compiler');
System.set(SystemJS.resolveSync('rxjs/operators'), System.newModule(m.operators));
System.import('$DEMOROOT$/en/lib/angular/license.ts');
System.import('./src/app.component');
});
</script>
</head>
<body>
<app-component></app-component>
</body>
</html>
<div class="sample-tutorial">
<gc-spread-sheets [hostStyle]="hostStyle" (workbookInitialized)="initSpread($event)">
</gc-spread-sheets>
<div class="options-container">
<div class="option-row">
Select a shape and change the arrow-head properties to see the effect.
</div>
<div id="divideLine" class="divide-line"></div>
<div *ngIf="showConnectorPropPanel" class="option-row">
<label for="beginArrowheadStyle">Begin Arrowhead Style:</label>
<select [(ngModel)]="beginStyle" class="shapeSelect">
<option *ngFor="let item of arrowHeadStyle" [value]="item.value|number">
{{item.name}}
</option>
</select>
<input (click)="updateConnectorShapeStyle('beginStyle', beginStyle)" type="button" class='arrow-action-button' value="Set" />
<label>Begin Arrowhead Width:</label>
<select [(ngModel)]="beginWidth" class="shapeSelect">
<option *ngFor="let item of arrowHeadWidthList" [value]="item.value|number">
{{item.name}}
</option>
</select>
<input type="button" (click)="updateConnectorShapeStyle('beginWidth', beginWidth)" class='arrow-action-button' value="Set" />
<label>Begin Arrowhead Length:</label>
<select [(ngModel)]="beginLength" class="shapeSelect">
<option *ngFor="let item of arrowHeadLengthList" [value]="item.value|number">
{{item.name}}
</option>
</select>
<input type="button" (click)="updateConnectorShapeStyle('beginLength', beginLength)" class='arrow-action-button' value="Set" />
<label for="endArrowheadStyle">End Arrowhead Style:</label>
<select [(ngModel)]="endStyle" class="shapeSelect">
<option *ngFor="let item of arrowHeadStyle" [value]="item.value|number">
{{item.name}}
</option>
</select>
<input type="button" (click)="updateConnectorShapeStyle('endStyle', endStyle)" class='arrow-action-button' value="Set" />
<label>End Arrowhead Width:</label>
<select [(ngModel)]="endWidth" class="shapeSelect">
<option *ngFor="let item of arrowHeadWidthList" [value]="item.value|number">
{{item.name}}
</option>
</select>
<input type="button" (click)="updateConnectorShapeStyle('endWidth', endWidth)" class='arrow-action-button' value="Set" />
<label>End Arrowhead Length:</label>
<select [(ngModel)]="endLength" class="shapeSelect">
<option *ngFor="let item of arrowHeadLengthList" [value]="item.value|number">
{{item.name}}
</option>
</select>
<input type="button" (click)="updateConnectorShapeStyle('endLength', endLength)" class='arrow-action-button' value="Set" />
</div>
</div>
</div>
.sample-tutorial {
position: relative;
height: 100%;
overflow: hidden;
}
.sample-spreadsheets {
width: calc(100% - 280px);
height: 100%;
overflow: hidden;
float: left;
}
.options-container {
float: right;
width: 280px;
padding: 12px;
height: 100%;
box-sizing: border-box;
background: #fbfbfb;
overflow: auto;
}
.option-row {
font-size: 14px;
padding-left: 5px;
}
.divide-line {
width: 100%;
height: 1px;
background: #cbcbcb;
margin-top: 10px;
margin-bottom: 3px;
}
.title {
text-align: center;
font-weight: bold;
}
label {
display: block;
margin-top: 15px;
margin-bottom: 5px;
}
p {
padding: 2px 10px;
background-color: #F4F8EB;
}
input {
width: 160px;
margin-left: 10px;
display: inline;
}
input[type=button] {
width: 50px;
margin-left: 1px;
}
select {
width: 160px;
margin-left: 10px;
display: inline;
}
textarea {
width: 160px;
margin-left: 10px;
}
body {
position: absolute;
top: 0;
bottom: 0;
left: 0;
right: 0;
}
(function (global) {
System.config({
transpiler: 'ts',
typescriptOptions: {
tsconfig: true
},
meta: {
'typescript': {
"exports": "ts"
},
'*.css': { loader: 'css' }
},
paths: {
// paths serve as alias
'npm:': 'node_modules/'
},
// map tells the System loader where to look for things
map: {
'core-js': 'npm:core-js/client/shim.min.js',
'zone': 'npm:zone.js/fesm2015/zone.min.js',
'rxjs': 'npm:rxjs/dist/bundles/rxjs.umd.min.js',
'@angular/core': 'npm:@angular/core/fesm2022',
'@angular/common': 'npm:@angular/common/fesm2022/common.mjs',
'@angular/compiler': 'npm:@angular/compiler/fesm2022/compiler.mjs',
'@angular/platform-browser': 'npm:@angular/platform-browser/fesm2022/platform-browser.mjs',
'@angular/platform-browser-dynamic': 'npm:@angular/platform-browser-dynamic/fesm2022/platform-browser-dynamic.mjs',
'@angular/common/http': 'npm:@angular/common/fesm2022/http.mjs',
'@angular/router': 'npm:@angular/router/fesm2022/router.mjs',
'@angular/forms': 'npm:@angular/forms/fesm2022/forms.mjs',
'jszip': 'npm:jszip/dist/jszip.min.js',
'typescript': 'npm:typescript/lib/typescript.js',
'ts': './plugin.js',
'tslib':'npm:tslib/tslib.js',
'css': 'npm:systemjs-plugin-css/css.js',
'plugin-babel': 'npm:systemjs-plugin-babel/plugin-babel.js',
'systemjs-babel-build':'npm:systemjs-plugin-babel/systemjs-babel-browser.js',
'@mescius/spread-sheets': 'npm:@mescius/spread-sheets/index.js',
'@mescius/spread-sheets-shapes': 'npm:@mescius/spread-sheets-shapes/index.js',
'@mescius/spread-sheets-angular': 'npm:@mescius/spread-sheets-angular/fesm2020/mescius-spread-sheets-angular.mjs',
'@grapecity/jsob-test-dependency-package/react-components': 'npm:@grapecity/jsob-test-dependency-package/react-components/index.js'
},
// packages tells the System loader how to load when no filename and/or no extension
packages: {
src: {
defaultExtension: 'ts'
},
rxjs: {
defaultExtension: 'js'
},
"node_modules": {
defaultExtension: 'js'
},
"node_modules/@angular": {
defaultExtension: 'mjs'
},
"@mescius/spread-sheets-angular": {
defaultExtension: 'mjs'
},
'@angular/core': {
defaultExtension: 'mjs',
main: 'core.mjs'
}
}
});
})(this);

You can customize the properties of connectorShapes using the ConnectorShape API:
style: Gets or sets the style of the connector shape.
<template>
<div class="sample-tutorial">
<gc-spread-sheets class="sample-spreadsheets" @workbookInitialized="initSpread">
</gc-spread-sheets>
<shape-panel @updateConnectorShapeStyle="updateConnectorShapeStyle"
:showConnectorPropPanelRef="showConnectorPropPanelRef">
</shape-panel>
</div>
</template>
<script setup>
import GC from "@mescius/spread-sheets";
import { ref, createApp } from "vue";
import "@mescius/spread-sheets-vue";
import '@mescius/spread-sheets-shapes';
const spreadRef = ref(null);
const showConnectorPropPanelRef = ref(false);
const updateConnectorShapeStyle = (action, value) => {
let sheet = spreadRef.value.getActiveSheet();
let activeShape = sheet.shapes.all().filter(function (sp) {
return sp.isSelected() && sp instanceof GC.Spread.Sheets.Shapes.ConnectorShape;
});
if (activeShape.length > 0) {
activeShape.forEach((shape) => {
_setConnectorShapeStyle(shape, action, value);
});
sheet.repaint();
}
}
const _setConnectorShapeStyle = (shape, action, value) => {
let shapeStyle = shape.style();
let shapeStyleLine = shapeStyle.line;
switch (action) {
case "beginStyle": {
shapeStyleLine.beginArrowheadStyle = value;
break;
}
case "beginWidth": {
shapeStyleLine.beginArrowheadWidth = value;
break;
}
case "beginLength": {
shapeStyleLine.beginArrowheadLength = value;
break;
}
case "endStyle": {
shapeStyleLine.endArrowheadStyle = value;
break;
}
case "endWidth": {
shapeStyleLine.endArrowheadWidth = value;
break;
}
case "endLength": {
shapeStyleLine.endArrowheadLength = value;
break;
}
}
shape.style(shapeStyle);
}
const bindSpreadEvent = () => {
spreadRef.value.bind(GC.Spread.Sheets.Events.ShapeSelectionChanged, function () {
let sheet = spreadRef.value.getActiveSheet();
var selectedShape = sheet.shapes.all().filter(function (sp) {
return sp.isSelected();
});
var isShapeSelected = false,
isConnectorSelected = false;
if (selectedShape.length > 0) {
selectedShape.forEach((shape) => {
if (!isShapeSelected && shape instanceof GC.Spread.Sheets.Shapes.Shape) {
isShapeSelected = true;
} else if (!isConnectorSelected && shape instanceof GC.Spread.Sheets.Shapes.ConnectorShape) {
isConnectorSelected = true;
}
});
setConnectorPropVisibility(isConnectorSelected);
} else {
setConnectorPropVisibility(false);
}
})
}
const setConnectorPropVisibility = (isShow) => {
showConnectorPropPanelRef.value = isShow;
}
const initSpread = (spread) => {
spreadRef.value = spread;
var line1 = spread.getActiveSheet().shapes.addConnector("line", GC.Spread.Sheets.Shapes.ConnectorType.straight, 20, 40, 200, 110);
var line2 = spread.getActiveSheet().shapes.addConnector("line", GC.Spread.Sheets.Shapes.ConnectorType.straight, 20, 110, 200, 190);
var line3 = spread.getActiveSheet().shapes.addConnector("line", GC.Spread.Sheets.Shapes.ConnectorType.elbow, 300, 40, 500, 90);
var line4 = spread.getActiveSheet().shapes.addConnector("line", GC.Spread.Sheets.Shapes.ConnectorType.elbow, 300, 130, 500, 190);
var lineShapeStyle = line1.style();
lineShapeStyle.line.width = 3;
lineShapeStyle.line.color = "#82BC00";
line1.style(lineShapeStyle);
line2.style(lineShapeStyle);
line3.style(lineShapeStyle);
line4.style(lineShapeStyle);
bindSpreadEvent();
}
</script>
<style scoped>
.sample-tutorial {
position: relative;
height: 100%;
overflow: hidden;
}
.sample-spreadsheets {
width: calc(100% - 280px);
height: 100%;
overflow: hidden;
float: left;
}
.options-container {
float: right;
width: 280px;
padding: 12px;
height: 100%;
box-sizing: border-box;
background: #fbfbfb;
overflow: auto;
}
.option-row {
font-size: 14px;
padding-left: 5px;
}
.divide-line {
width: 100%;
height: 1px;
background: #cbcbcb;
margin-top: 10px;
margin-bottom: 3px;
}
.title {
text-align: center;
font-weight: bold;
}
label {
display: block;
margin-top: 15px;
margin-bottom: 5px;
}
p {
padding: 2px 10px;
background-color: #F4F8EB;
}
input {
width: 160px;
margin-left: 10px;
display: inline;
}
input[type=button] {
width: 50px;
margin-left: 1px;
}
select {
width: 160px;
margin-left: 10px;
display: inline;
}
textarea {
width: 160px;
margin-left: 10px;
}
body {
position: absolute;
top: 0;
bottom: 0;
left: 0;
right: 0;
}
#app {
height: 100%;
}
</style>
<template>
<div class="options-container">
<div class="option-row">
Select a shape and change the arrow-head properties to see the effect.
</div>
<div id="divideLine" class="divide-line"></div>
<div v-show="props.showConnectorPropPanelRef" class="option-row">
<label for="beginArrowheadStyle">Begin Arrowhead Style:</label>
<select v-model="beginStyleRef" id="beginArrowheadStyle" class="shapeSelect">
<option :value="item.value" v-for="item in arrowHeadStyleRef" :key="item.name"> {{ item.name }}</option>
</select>
<input @click="_handleConnectorShapeStyleSetting('beginStyle', beginStyleRef)" type="button"
class='arrow-action-button' value="Set" />
<label>Begin Arrowhead Width:</label>
<select v-model="beginWidthRef" class="shapeSelect">
<option :value="item.value" v-for="item in arrowHeadWidthListRef" :key="item.name"> {{ item.name }}</option>
</select>
<input type="button" @click="_handleConnectorShapeStyleSetting('beginWidth', beginWidthRef)"
class='arrow-action-button' value="Set" />
<label>Begin Arrowhead Length:</label>
<select v-model="beginLengthRef" class="shapeSelect">
<option :value="item.value" v-for="item in arrowHeadLengthListRef" :key="item.name"> {{ item.name }}</option>
</select>
<input type="button" @click="_handleConnectorShapeStyleSetting('beginLength', beginLengthRef)"
class='arrow-action-button' value="Set" />
<label for="endArrowheadStyle">End Arrowhead Style:</label>
<select v-model="endStyleRef" id="endArrowheadStyle" class="shapeSelect">
<option :value="item.value" v-for="item in arrowHeadStyleRef" :key="item.name"> {{ item.name }}</option>
</select>
<input type="button" @click="_handleConnectorShapeStyleSetting('endStyle', endStyleRef)"
class='arrow-action-button' value="Set" />
<label>End Arrowhead Width:</label>
<select v-model="endWidthRef" class="shapeSelect">
<option v-bind:value="item.value" v-for="item in arrowHeadWidthListRef" :key="item.name">{{ item.name }}
</option>
</select>
<input type="button" @click="_handleConnectorShapeStyleSetting('endWidth', endWidthRef)"
class='arrow-action-button' value="Set" />
<label>End Arrowhead Length:</label>
<select v-model="endLengthRef" class="shapeSelect">
<option v-bind:value="item.value" v-for="item in arrowHeadLengthListRef" :key="item.name">{{ item.name }}
</option>
</select>
<input type="button" @click="_handleConnectorShapeStyleSetting('endLength', endLengthRef)"
class='arrow-action-button' value="Set" />
</div>
</div>
</template>
<script setup>
import GC from "@mescius/spread-sheets";
import "@mescius/spread-sheets-shapes";
import { defineEmits, defineProps, ref } from 'vue';
let arrowheadLength = {
"short": 0,
"medium": 1,
"long": 2
};
let arrowheadWidth = {
"narrow": 0,
"medium": 1,
"wide": 2
};
const beginStyleRef = ref(3);
const beginWidthRef = ref(1);
const beginLengthRef = ref(2);
const endStyleRef = ref(3);
const endWidthRef = ref(1);
const endLengthRef = ref(2);
const arrowHeadLengthListRef = ref(getEnumList(arrowheadLength));
const arrowHeadWidthListRef = ref(getEnumList(arrowheadWidth));
const arrowHeadStyleRef = ref(getEnumList(GC.Spread.Sheets.Shapes.ArrowheadStyle));
const props = defineProps({ showConnectorPropPanelRef: Boolean });
const emits = defineEmits(['updateConnectorShapeStyle']);
const _handleConnectorShapeStyleSetting = (action, value) => {
emits("updateConnectorShapeStyle", action, value);
}
function getEnumList(enumObject) {
let names = [];
for (var name in enumObject) {
if (name === "none" || (parseInt(name, 10)) == name) {
continue;
}
names.push({
name: name,
value: enumObject[name]
});
}
names.sort(function (a, b) {
return a.name > b.name ? 1 : -1
});
return names;
}
</script>
<style scoped></style>
<!DOCTYPE html>
<html style="height:100%;font-size:14px;">
<head>
<meta charset="utf-8" />
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<title>SpreadJS VUE</title>
<meta name="viewport" content="width=device-width, initial-scale=1.0" />
<link rel="stylesheet" type="text/css"
href="$DEMOROOT$/en/vue3/node_modules/@mescius/spread-sheets/styles/gc.spread.sheets.excel2013white.css">
<script src="$DEMOROOT$/spread/source/data/inventory-tracker.js" type="text/javascript"></script>
<script src="$DEMOROOT$/en/vue3/node_modules/systemjs/dist/system.src.js"></script>
<script src="./systemjs.config.js"></script>
<script src="./compiler.js" type="module"></script>
<script>
var System = SystemJS;
System.import("./src/app.js");
System.import('$DEMOROOT$/en/lib/vue3/license.js');
</script>
</head>
<body>
<div id="app"></div>
</body>
</html>
(function (global) {
SystemJS.config({
transpiler: 'plugin-babel',
babelOptions: {
es2015: true
},
paths: {
// paths serve as alias
'npm:': 'node_modules/'
},
packageConfigPaths: [
'./node_modules/*/package.json',
"./node_modules/@mescius/*/package.json",
"./node_modules/@babel/*/package.json",
"./node_modules/@vue/*/package.json"
],
map: {
'vue': "npm:vue/dist/vue.esm-browser.js",
'tiny-emitter': 'npm:tiny-emitter/index.js',
'plugin-babel': 'npm:systemjs-plugin-babel/plugin-babel.js',
"systemjs-babel-build": "npm:systemjs-plugin-babel/systemjs-babel-browser.js",
'@mescius/spread-sheets': 'npm:@mescius/spread-sheets/index.js',
'@mescius/spread-sheets-shapes': 'npm:@mescius/spread-sheets-shapes/index.js',
'@mescius/spread-sheets-vue': 'npm:@mescius/spread-sheets-vue/index.js'
},
meta: {
'*.css': { loader: 'systemjs-plugin-css' },
'*.vue': { loader: "../plugin-vue/index.js" }
}
});
})(this);